## LittleBigCity

<p align="center">
  <img src="img/logo_LBCity.png" />
</p>

# The project
LittleBigCity is an open source project inspired by CityLearn that aims to simulate the operation of a Smartgrid with two types of actors:

- Several consumers consume, store and produce electricity.
- A single producer produce the energy needed by the grid.

The following figure illustrates the smartgrid with the arrow lines representing electricity transfers. The blue line corresponds to the transfers of a classic grid whereas the yellow line are specific to the smartgrid. 

![Smartgrid](img/littlebigcity_schema.png "Smartgrid schema")


This project uses [Gym](https://github.com/openai/gym) environments to simplify RL (Reinforcement Learning) agents implementation.

# References

- [ISGAN](https://www.iea-isgan.org/): Internation SmartGrid Action Network: an organization gathering energy experts and holding an annual smartgrid contest 
- [NREL Data viewer](https://maps.nrel.gov/nsrdb-viewer/): open database for weather data from the National Renewable Energy Laboratory
- [Citylearn](https://github.com/intelligent-environments-lab/CityLearn): opensource smartgrid simulator inspiring our project

# How does LittleBigCity differ from CityLearn?
We differ from CityLearn on several aspects of the project.
- We consider the Smartgrid as a bipartite network: the producers and the consumers whereas CityLearn only considers consumers
- We simplified consumer assets by using 4 assets per consumer: solar panel, battery, electric heater and heat pump.  
- We added an economic feature to the simulator. The electricity interaction between producer and consumers create an electricity cost. 
- We built a vizualisation tool with Streamlit to simplify the observation of the smartgrid and of the agents' behaviours.

# What has to come ?
Several features are already in development:
- A streamlit mode to simplify building setting modifications.
- New default agents for producer and consumer using RL.
- More weather datasets (from different climate types).
- A dockerfile to ease the deployment of the project.
- Adding test pipeline (Continuous Integration)

# Configuration & run

This project can be run on Windows 10 with Python 3.10.3.
We recommend the use of a virtual environment as seen [here](https://docs.python.org/fr/3/library/venv.html).
In order to run this project, you might need to install the few dependencies in the requirements.txt with

````bash
pip install -r requirements.txt
````

Then you can run the project by executing the main
````bash
python src/examples/smartgrid_example.py
````

We implemented a [streamlit](https://github.com/streamlit/streamlit) viz to allow users to have a better view of the simulation. You can run it with
````bash
streamlit run streamlit_app.py
````
or 
````bash
python -m streamlit run streamlit_app.py
````
# Files
````
- data
  - *.csv: weather files
  - buildings.json: building file
- img
  - *.png: images used in the README and the vizualisation
- src
  - config.py: global configuration file
  - smartgrid
    - components
        - *.py: components used in the simulation
    - smartgrid_*.py: smartgrid classes and reward functions
    - building.py: building class
    - data_loader.py: data loader functions
    - examples
      - *.py: examples of use of the project
    - agents
      - producer_agents
        - *.py: producer agent classes
      - consumer_agents
        - *.py: consumer agent classes
- streamlit_app.py: visualization tool
````

# Classes
- SmartGridConsumer : a Gym environment for the consumers
- Building: class representing a building
- Building components
    - SolarPanel : component for electricity production
    - ElectricityStorage : component for electricity storage
    - ElectricHeater : component for heating
    - HeatPump : component for heating or cooling
- SmartGridProducer : a Gym environment for the producer

# Global variables
A substantial number of global variables can be found in config.py.

Weather variables:
````
- CITIES is a list of the cities which have a weather file
- ID_CITY is the id of the above city whose weather data will be used in the simulation
- WEATHER_PATH is the relative path to the weather file of the above city
````

For the consumer side variables
````
- BUILDING_PATH is the relative path to the json file which contain the description of buildings we will use in the simulation.
- G_ISO is a list with the possible heat loss coefficient for the buildings (a lower heat loss coefficient means that the insulation is better)
````
For the producer side variables
````
- ENERGY_TYPES is the list of the different energy production type
- ENERGY_COLORS is the list of the colors associated to these types
- POWER_EFFICIENCY is the list of the power efficiency of these types
- POSSIBLE_PERCENTAGE is the list of the maximum percentage of the max_demand that can be generated by these types (TODO improve phrasing)
- ENERGY_PRICES are the cost to produce 1 kWh of electricy for each production type
- MEAN_SOLAR_INCIDENT is the mean of the solar incident energy throughout the year (it is used to calculate the production of solar energy)
- OPTI_WIND_SPEED is the max of the wind speed throughout the year (it is used to calculate the production of the wind energy)
- MIN_WIND_SPEED is the minimum wind speed to generate wind electricity
- NUCLEAR_STARTING_TIME: the number of hours to start nuclear production
- FOSSIL_STARTING_TIME: the number of hours to start fossil production
- ELEC_PRICE is the price of electricity for exportation and importation (not implemented yet)
- PRODUCER_MARGIN: the margin of profit for the producer as a percentage
````
For simulation side variables
````
- INITIAL_DAY is the first day of the simulation
- NB_DAYS is the total number of days of the simulation
````
For agent side variables
````
- T_MIN and T_MAX are the minimum and maximum temperature that the building can take. Otherwise, the reward is set to inf_reward
- INF_REWARD is the worst possible reward
````
# How to contribute ? 
Anyone willing to help this project is welcome. The only requirement is to respect current coding conventions. That means:
- code  must be well documented using [Google style guide](https://google.github.io/styleguide/pyguide.html)
- code must follow [Flake8 Style Guide](https://flake8.pycqa.org/en/latest/index.html)
- commit must be done using [Karma style](https://karma-runner.github.io/1.0/config/configuration-file.html)


# Contact

- Paul-Adrien Nicole: [Linkedin](https://www.linkedin.com/in/paul-adrien-nicole-5664a11aa/) / [email](mailto:panicole@littlebigcode.fr)
- Johan Jublanc: [Linkedin](https://www.linkedin.com/in/johan-jublanc-210b597b/) / [email](mailto:jjublanc@littlebigcode.fr)
- Simon Provost: [Linkedin](https://www.linkedin.com/in/simonprovostdev/) / 
  [email](mailto:sprovost@littlebigcode.fr)

# Licence
MIT License

Copyright (c) 2022 LittleBigCode

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
